# Introduction #

This is an implementation of a simple 2d physics simulator usable from
the pytorch framework.

The main function is

```
torch.ByteTensor generate_sequence(bool pulling,
                                   int nb_sequences,
                                   int nb_images,
                                   int image_height, int image_width,
                                   int nb_shapes,
                                   bool random_shape_size, bool random_colors)
```

where

 * `pulling` indicates if one of the shape should be pulled upward,
 * `nb_sequences` is the number of sequences to generate,
 * `nb_images` is the number of frames per sequence,
 * `image_height` and `image_width` is the individual image size,
 * `nb_shapes` is the number of rectangular shapes in the simulation,
 * `random_shape_size` states if the shapes should be of different sizes,
 * `random_colors` states if they should be of different colors.

The returned ByteTensor has five dimensions:

 * Sequence index
 * Image index
 * Channel (3 since it is RGB)
 * Pixel row
 * Pixel col

Warning: For improper parameters values (e.g. too many shapes, too
small images), the simulation may be stuck.

# Installation and test #

```
make -j -k
./built.py
./flatland-test.py
```
